<?php

	############################################################################
	# 	
	#	Meteotemplate
	# 	http://www.meteotemplate.com
	# 	Free website template for weather enthusiasts
	# 	Author: Jachym
	#           Brno, Czech Republic
	# 	First release: 2015
	#
	############################################################################
	#
	#	Data Quality Control
	#
	# 	This page allows you to analyze the data in the database. The script tries to 
	#	automatically detect suspicious values, which require your attention
	#	and maybe also correction. It can be very useful, but it is necessary that you 
	#	read the information below so that you use it correctly.
	#
	############################################################################
	#	Version and change log
	#
	# 	v1.0 - Apr 24, 2016
	# 		- initial release
	# 	v1.1 - Apr 25, 2016
	# 		- bug fixes
	# 	v1.2 - Apr 12, 2017
	# 		- minor improvements
	# 		- bug fixes
	#
	############################################################################

	include("../../config.php");
	include($baseURL."css/design.php");
	include($baseURL."header.php");
	
	if(!file_exists("settings.php")){
		echo "Missing settings file, create one using the plugin setup.";
		die();
	}
	else{
		include("settings.php");
	}
	
	$default['gapInterval'] = $gapInterval;
	$default['tempMin'] = explode(",",$tempMin); // minimum temperature
	$default['tempMax'] = explode(",",$tempMax);
	$default['humidityMin'] = explode(",",$humidityMin);
	$default['humidityMax'] = explode(",",$humidityMax);
	$default['pressureMin'] = explode(",",$pressureMin);
	$default['pressureMax'] = explode(",",$pressureMax);
	$default['windMax'] = explode(",",$windMax);
	$default['gustMax'] = explode(",",$gustMax);
	$default['rainMax'] = explode(",",$rainMax);
	$default['apparentMin'] = explode(",",$apparentMin);
	$default['apparentMax'] = explode(",",$apparentMax);
	$default['tempRate'] = $tempRate;
	$default['humidityRate'] = $humidityRate;
	$default['pressureRate'] = $pressureRate;
	$default['rainRate'] = $rainRate;
	
	$result = mysqli_query($con,"
		SELECT DateTime
		FROM alldata 
		ORDER BY DateTime
		LIMIT 1
	"
	);
	while($row = mysqli_fetch_array($result)){
		$minDate = strtotime($row['DateTime']);
	}
?>
<!DOCTYPE html>
<html>
	<head>
		<title><?php echo lang("data quality check",'c')?></title>
		<?php metaHeader()?>
		<script type="text/javascript" src="<?php echo $pageURL.$path?>scripts/jquery.tablesorter.js"></script>
		<script type="text/javascript" src="<?php echo $pageURL.$path?>scripts/highcharts.js"></script>
		<script type="text/javascript" src="<?php echo $pageURL.$path?>scripts/highcharts-more.js"></script>
		<script type="text/javascript" src="<?php echo $pageURL.$path?>scripts/exporting.js"></script>
		<style>
			h3{
				text-align: center;
			}
			.sort{
				width: 15px;
				cursor: pointer;
				opacity: 0.8;
			}
			.sort:hover{
				opacity: 1;
			}
			.parameterCheckIcon{
				width: 25px;
			}
			.rate{
				padding: 5px;
				margin-right: 10px;
			}
			.outlier{
				padding: 4px;
				text-align: center;
			}
			.sectionDiv{
				width:98%;
				padding-top:10px;
				padding-bottom: 20px;
				margin: 0 auto;
				background: #<?php echo $color_schemes[$design2]['900']?>;
			}
			#showInfo{
				width:40px;
				cursor: pointer;
				opacity: 0.8;
			}
			#showInfo:hover{
				opacity: 1;
			}
		</style>
	</head>
	<body>
		<div id="main_top">
			<?php bodyHeader()?>
			<?php include($baseURL."menu.php");?>
		</div>
		<div id="main" style="text-align:center">
			<h1><?php echo lang('data quality control','c')?></h1>
			<div class="sectionDiv">
				<h2><?php echo lang('settings','c')?></h2>
				<div style="width:95%;margin:0 auto;text-align:right">
					<img id="showInfo" src="<?php echo $pageURL.$path?>icons/info.png">
				</div>
				<br><br>
					<table style="width:98%;margin:0 auto">
						<tr>
							<td style="width:40%;text-align:left">
								<table>
									<tr>
										<td colspan="2">
											<h3><?php echo lang('interval','c')?></h3>
										</td>
									</tr>
									<tr>
										<td>
											<?php echo lang("from",'c')?>
										</td>
										<td style="text-align:left">
											<input id='intervalFrom' value="<?php echo date("Y")?>-01-01" class="button2 rate">
										</td>
									</tr>
									<tr>
										<td>
											<?php echo lang("to",'c')?>
										</td>
										<td style="text-align:left">
											<input id='intervalTo' value="<?php echo date("Y-m-d")?>" class="button2 rate">
										</td>
									</tr>
									<tr>
										<td colspan="2">
											<h3><?php echo lang('gaps','c')?></h3>
										</td>
									</tr>
									<tr>
										<td>
											<?php echo lang('interval','c')?>
										</td>
										<td style="text-align:left">
											<input id="gapInterval" value="<?php echo $default['gapInterval']?>" class="button2 rate" size="3"> min
										</td>
									</tr>
									<tr>
										<td colspan="2">
											<h3><?php echo lang('spikes','c')?></h3>
										</td>
									</tr>
									<tr>
										<td>	
											<img src="<?php echo $pageURL.$path?>icons/temp.png" class="parameterCheckIcon">
										</td>
										<td style="text-align:left">
											<input id="rateChangeT" value="<?php echo $default['tempRate']?>" size="4" class="button2 rate"> °<?php echo $dataTempUnits?> / 10 min
										</td>
									</tr>
									<tr>
										<td>	
											<img src="<?php echo $pageURL.$path?>icons/apparent.png" class="parameterCheckIcon">
										</td>
										<td style="text-align:left">
											<input id="rateChangeA" value="<?php echo $default['tempRate']?>" size="4" class="button2 rate"> °<?php echo $dataTempUnits?> / 10 min
										</td>
									</tr>
									<tr>
										<td>
											<img src="<?php echo $pageURL.$path?>icons/humidity.png" class="parameterCheckIcon">
										</td>
										<td style="text-align:left">
											<input id="rateChangeH" value="<?php echo $default['humidityRate']?>" size="4" class="button2 rate"> % / 10 min
										</td>
									</tr>
									<tr>
										<td>
											<img src="<?php echo $pageURL.$path?>icons/pressure.png" class="parameterCheckIcon">
										</td>
										<td style="text-align:left">
											<input id="rateChangeP" value="<?php echo $default['pressureRate']?>" size="4" class="button2 rate"> <?php echo $dataPressUnits?> / 10 min
										</td>
									</tr>
									<tr>
										<td>
											<img src="<?php echo $pageURL.$path?>icons/rain.png" class="parameterCheckIcon">
										</td>
										<td style="text-align:left">
											<input id="rateChangeR" value="<?php echo $default['rainRate']?>" size="4" class="button2 rate"> <?php echo $dataRainUnits?> / 10 min
										</td>
									</tr>
								</table>
							</td>
							<td style="vertical-align:top;width:60%">
								<table style="width:98%;margin:0 auto">
									<tr>
										<td></td>
										<td colspan="2">
											<img src="<?php echo $pageURL.$path?>icons/temp.png" class="parameterCheckIcon">
										</td>
										<td colspan="2">
											<img src="<?php echo $pageURL.$path?>icons/apparent.png" class="parameterCheckIcon">
										</td>
										<td colspan="2">
											<img src="<?php echo $pageURL.$path?>icons/humidity.png" class="parameterCheckIcon">
										</td>
										<td colspan="2">
											<img src="<?php echo $pageURL.$path?>icons/pressure.png" class="parameterCheckIcon">
										</td>
										<td>
											<img src="<?php echo $pageURL.$path?>icons/wind.png" class="parameterCheckIcon">
										</td>
										<td>
											<img src="<?php echo $pageURL.$path?>icons/gust.png" class="parameterCheckIcon">
										</td>
										<td>
											<img src="<?php echo $pageURL.$path?>icons/rain.png" class="parameterCheckIcon">
										</td>	
									</tr>	
									<tr>
										<td>
										</td>
										<td>
											<?php echo lang('minimumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('maximumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('minimumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('maximumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('minimumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('maximumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('minimumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('maximumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('maximumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('maximumAbbr','c')?>
										</td>
										<td>
											<?php echo lang('maximumAbbr','c')?>
										</td>
									</tr>
									<?php 
										for($i=1;$i<13;$i++){
									?>
										<tr>
											<td>
												<?php echo lang('month'.$i.'short','c')?>
											</td>
											<td>
												<input id="minT<?php echo $i?>" value="<?php echo $default['tempMin'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="maxT<?php echo $i?>" value="<?php echo $default['tempMax'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="minA<?php echo $i?>" value="<?php echo $default['apparentMin'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="maxA<?php echo $i?>" value="<?php echo $default['apparentMax'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="minH<?php echo $i?>" value="<?php echo $default['humidityMin'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="maxH<?php echo $i?>" value="<?php echo $default['humidityMax'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="minP<?php echo $i?>" value="<?php echo $default['pressureMin'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="maxP<?php echo $i?>" value="<?php echo $default['pressureMax'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="maxW<?php echo $i?>" value="<?php echo $default['windMax'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="maxG<?php echo $i?>" value="<?php echo $default['gustMax'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
											<td>
												<input id="maxR<?php echo $i?>" value="<?php echo $default['rainMax'][($i-1)]?>" size="4" class="button2 outlier">
											</td>
										</tr>
									<?php
										}
									?>
								</table>
								<?php echo lang('memory limit','c')?> <input id="memory" value="1" size="2" class="button2 outlier">
							</td>
						</tr>
					</table>
				<input type="button" class="button" value="<?php echo lang("ok",'u')?>" id="loadAnalysis">
				</div>
				<br>
				<div id="result" style="width:100%">
				<br><br>
				<div id="infoDiv" title="Data Quality Check">
					<h1>Data Quality Check</h1>
					<p>
						This page allows you to analyze the data in the database. The script tries to automatically detect suspicious values, which require your attention and maybe also correction. It can be very useful, but it is necessary that you read the information below so that you use it correctly - <b>especially do not skip the last part that explains what the "memory" parameter is and how it works</b>.
					</p>
					<p>
						Before you start the analysis you need to set the parameters for the analysis. First you need to choose the interval you want to analyze. By default the fields will contain interval for the current year. Dates are chosen using a popup calendar and interval corresponds to what you have in the database.
					</p>
					<p>
						Once you have chosen the interval you need to select gap interval. One of the functions in the analysis looks for gaps in data. Here you must specify, what is the minimum interval that should be considered as a gap. This interval should be a number in minutes.
					</p>
					<p>
						Next section are the spikes. Spikes in this case are suddenly changing numbers. The actual values can be within the normal limits, but they are likely to be incorrect because the rate of change is too high. The number you specify is the minimum rate of change per 10 minutes that should be considered as a spike. So, for example, if you put 10 degrees Celsius for the temperature, then a spike will be any number, where the rate of change for temperature was equal to or higher than 10 degrees. Remember this is per 10 minutes, which means the numbers are adjusted based on your database interval. If for example you have database interval of 5 minutes, then a spike in this case would be a number where the difference between subsequent updates is 5 or more degrees. Likewise, if there was a longer gap, then a higher number would be acceptable.
					</p>
					<p>
						Last thing to set up are the outliers. Outliers are number that are out of the bounds specified. You can set here specific limits, i.e. minimum and maximum, for each parameter and each month. An outlier would then be any number which is either equal to or above or below the specified number for that parameter and month. 
					</p>
					<p>
						The analysis will also show you a section called "nonsense values". There are certain fixed rules that the script checks and if the numbers do not comply with these, it will be evaluated as a nonsense value.<br><br>
						Here is a list of what is considered as nonsense value:
						<ul>
							<li>humidity below 0%</li>
							<li>humidity above 100%</li>
							<li>temperature/apparent temperature below -100 degrees</li>
							<li>temperature/apparent temperature above 150 degrees</li>
							<li>pressure below 0</li>
							<li>pressure above 1100</li>
							<li>wind speed below 0</li>
							<li>wind gust below 0</li>
							<li>daily rain below 0</li>
							<li>wind direction degrees below 0</li>
							<li>wind direction degrees above 360</li>
						</ul>
						This is especially intended for situations where for example there is a problem with some of your sensors and the reported value is for example -9999 etc.
					</p>
					<p>
						Last field which you probably do not know what it means is the memory field. This needs a bit longer explanation. This script was originally in the main template, known as dbInfo. Because however, often people ran into problems due to memory limits of PHP, I had to discontinue it. The problem is that in PHP there is always a maximum allowed size you can allocate to an array. This can be set in the server settings. However, if you do not have your own server, then this is preset by your webhosting provider and you therefore cannot change it. There is a PHP command for increasing it, but in 99% of cases this cannot override the global setting by your provider.<br>
						In practice this means that if you chose a longer interval, more data had to be fetched from the MySQL database and soon the memory was exhausted and you just got an error.<br>
						I was thinking long time how to best solve this and tried several things. I finally came up with a workaround, but please, only take this as still <b>experimental</b> feature. Basically, you can increase the memory limit in the setting. Then, before the MySQL is queried, the intervals are spliced into chunks, each one is processed separately and then finally, the results are aggregated. When testing it, it seemed to be working fine, but I still need more people to confirm it is working.<br><br>
						The way it works is this<br>
						By default always leave this to "1". If however, you get an error showing the memory was exhausted, then try increasing the number always by 1, so if you get an error, try setting the memory limit to "2". If the error persists try "3" and so on. The smaller the number the better, so you want to make sure you choose the lowest number that already works.
					</p>
				</div>
			</div>
		</div>
		<?php include($baseURL."footer.php");?>
		<?php include("../../css/highcharts.php");?>
		<script>
			$( "#intervalFrom" ).datepicker({
				dateFormat: "yy-mm-dd",
				minDate: new Date(<?php echo date("Y",$minDate);?>,(<?php echo date("m",$minDate);?>-1),<?php echo date("d",$minDate);?>),
				maxDate: "+0d",
				changeMonth: true,
				changeYear: true,
				monthNamesShort: ['<?php echo lang('month1short','c')?>', '<?php echo lang('month2short','c')?>', '<?php echo lang('month3short','c')?>', '<?php echo lang('month4short','c')?>', '<?php echo lang('month5short','c')?>', '<?php echo lang('month6short','c')?>', '<?php echo lang('month7short','c')?>', '<?php echo lang('month8short','c')?>', '<?php echo lang('month9short','c')?>', '<?php echo lang('month10short','c')?>', '<?php echo lang('month11short','c')?>', '<?php echo lang('month12short','c')?>'],
				monthNames: ['<?php echo lang('month1short','c')?>', '<?php echo lang('month2short','c')?>', '<?php echo lang('month3short','c')?>', '<?php echo lang('month4short','c')?>', '<?php echo lang('month5short','c')?>', '<?php echo lang('month6short','c')?>', '<?php echo lang('month7short','c')?>', '<?php echo lang('month8short','c')?>', '<?php echo lang('month9short','c')?>', '<?php echo lang('month10short','c')?>', '<?php echo lang('month11short','c')?>', '<?php echo lang('month12short','c')?>'],
				firstDay: <?php echo $firstWeekday?>,
			});
			$( "#intervalTo" ).datepicker({
				dateFormat: "yy-mm-dd",
				minDate: new Date(<?php echo date("Y",$minDate);?>,(<?php echo date("m",$minDate);?>-1),<?php echo date("d",$minDate);?>),
				maxDate: "+0d",
				changeMonth: true,
				changeYear: true,
				monthNamesShort: ['<?php echo lang('month1short','c')?>', '<?php echo lang('month2short','c')?>', '<?php echo lang('month3short','c')?>', '<?php echo lang('month4short','c')?>', '<?php echo lang('month5short','c')?>', '<?php echo lang('month6short','c')?>', '<?php echo lang('month7short','c')?>', '<?php echo lang('month8short','c')?>', '<?php echo lang('month9short','c')?>', '<?php echo lang('month10short','c')?>', '<?php echo lang('month11short','c')?>', '<?php echo lang('month12short','c')?>'],
				monthNames: ['<?php echo lang('month1short','c')?>', '<?php echo lang('month2short','c')?>', '<?php echo lang('month3short','c')?>', '<?php echo lang('month4short','c')?>', '<?php echo lang('month5short','c')?>', '<?php echo lang('month6short','c')?>', '<?php echo lang('month7short','c')?>', '<?php echo lang('month8short','c')?>', '<?php echo lang('month9short','c')?>', '<?php echo lang('month10short','c')?>', '<?php echo lang('month11short','c')?>', '<?php echo lang('month12short','c')?>'],
				firstDay: <?php echo $firstWeekday?>,
			});
			$( "#loadAnalysis" ).click(function() {
				$("#result").html('<br><br><img src="<?php echo $pageURL.$path?>icons/logo.png" class="mtSpinner" id="spinner" style="width:80px"><br><br>');
				gap = $("#gapInterval").val();
				memory = $("#memory").val();
				from = encodeURIComponent($("#intervalFrom").val());
				to = encodeURIComponent($("#intervalTo").val());
				rateChangeT = $("#rateChangeT").val();
				rateChangeA = $("#rateChangeA").val();
				rateChangeH = $("#rateChangeH").val();
				rateChangeP = $("#rateChangeP").val();
				rateChangeR = $("#rateChangeR").val();
				<?php 
					for($i=1;$i<13;$i++){
				?>
						minT<?php echo $i?> = $("#minT<?php echo $i?>").val();
						maxT<?php echo $i?> = $("#maxT<?php echo $i?>").val();
						minH<?php echo $i?> = $("#minH<?php echo $i?>").val();
						maxH<?php echo $i?> = $("#maxH<?php echo $i?>").val();
						minA<?php echo $i?> = $("#minA<?php echo $i?>").val();
						maxA<?php echo $i?> = $("#maxA<?php echo $i?>").val();
						minP<?php echo $i?> = $("#minP<?php echo $i?>").val();
						maxP<?php echo $i?> = $("#maxP<?php echo $i?>").val();
						maxW<?php echo $i?> = $("#maxW<?php echo $i?>").val();
						maxG<?php echo $i?> = $("#maxG<?php echo $i?>").val();
						maxR<?php echo $i?> = $("#maxR<?php echo $i?>").val();
				<?php
					}
				?>
				url = ("gap=" + gap + "&from=" + from + "&to=" + to + "&rateT=" + rateChangeT + "&rateA=" + rateChangeA + "&rateH=" + rateChangeH + "&rateP=" + rateChangeP + "&rateR=" + rateChangeR + "&memory=" + memory);
				<?php 
					for($i=1;$i<13;$i++){
				?>
						url += "&minT<?php echo $i?>=" + minT<?php echo $i?> + "&maxT<?php echo $i?>=" + maxT<?php echo $i?>;
						url += "&minH<?php echo $i?>=" + minH<?php echo $i?> + "&maxH<?php echo $i?>=" + maxH<?php echo $i?>;
						url += "&minP<?php echo $i?>=" + minP<?php echo $i?> + "&maxP<?php echo $i?>=" + maxP<?php echo $i?>;
						url += "&minA<?php echo $i?>=" + minA<?php echo $i?> + "&maxA<?php echo $i?>=" + maxA<?php echo $i?>;
						url += "&maxW<?php echo $i?>=" + maxW<?php echo $i?>;
						url += "&maxG<?php echo $i?>=" + maxG<?php echo $i?>;
						url += "&maxR<?php echo $i?>=" + maxR<?php echo $i?>;
				<?php
					}
				?>
				
				$("#result").load("gapLoader.php?" + url);
			});
			$("#showInfo").click(function(){
				$( "#infoDiv" ).dialog( "open" );
			});
			$( "#infoDiv" ).dialog({
				autoOpen: false,
				show: {
					effect: "puff",
					duration: 500
				},
				hide: {
					effect: "puff",
					duration: 500
				},
				height: 800,
				width: '40%',
				position:{
					my: 'top', 
					at: 'top+5%'
				}
			});
		</script>
	</body>
</html>