<?php

	// check acces authorization
	session_start();
	if($_SESSION['user']!="admin"){
		echo "Unauthorized access.";
		die();
	}
	
	// load core files
	include("../../config.php");
	include($baseURL."css/design.php");
	include($baseURL."header.php");
	
	// check if settings already exists and if so, load it, otherwise set parameters to default values
	if(file_exists("settings.php")){
		include("settings.php");
	}

	if(!isset($gapInterval)){
		$gapInterval = 60;
	}
	if(!isset($tempMin)){
		$tempMin = "-15,-15,-10,-5,-5,0,5,5,0,0,-10,-15";
	}
	if(!isset($tempMax)){
		$tempMax = "15,20,25,30,30,35,35,35,30,30,20,15";
	}
	if(!isset($humidityMin)){
		$humidityMin = "20,20,20,20,20,20,20,20,20,20,20,20";
	}
	if(!isset($humidityMax)){
		$humidityMax = "100,100,100,100,100,100,100,100,100,100,100,100";
	}
	if(!isset($pressureMin)){
		$pressureMin = "985,985,985,985,985,985,985,985,985,985,985,985";
	}
	if(!isset($pressureMax)){
		$pressureMax = "1035,1035,1035,1035,1035,1035,1035,1035,1035,1035,1035,1035";
	}
	if(!isset($windMax)){
		$windMax = "60,60,60,60,60,60,60,60,60,60,60,60";
	}
	if(!isset($gustMax)){
		$gustMax = "80,80,80,80,80,80,80,80,80,80,80,80";
	}
	if(!isset($rainMax)){
		$rainMax = "80,80,80,80,80,80,80,80,80,80,80,80";
	}
	if(!isset($apparentMin)){
		$apparentMin = "-25,-25,-20,-10,0,0,0,0,-5,-5,-15,-25";
	}
	if(!isset($apparentMax)){
		$apparentMax = "15,15,20,25,35,40,40,40,35,30,25,15";
	}
	if(!isset($tempRate)){
		$tempRate = 5;
	}
	if(!isset($humidityRate)){
		$humidityRate = 20;
	}
	if(!isset($pressureRate)){
		$pressureRate = 5;
	}
	if(!isset($rainRate)){
		$rainRate = 10;
	}
	
?>
<!DOCTYPE html>
<html>
	<head>
		<title><?php echo $pageName?></title>
		<?php metaHeader()?>
		<style>
			
		</style>
	</head>
	<body>
		<div id="main_top">
			<?php bodyHeader()?>
			<?php include($baseURL."menu.php");?>
		</div>
		<div id="main" style="text-align:center">
			<h1>Data Check - Setup</h1>
			
			<form method="POST" action="saveSettings.php" target="_blank">
				<div style="width:98%;margin:0 auto;text-align:justify">
					I recommend that you first go to the DEMO page at meteotemplate.com and click the "info" icon. Everything is explained there in more detail. Then go back here and set the defaults. All these can then be changed directly on the page, this is only to set what is prefilled.
				</div>
				<br><br>
				<table style="width:98%;margin:0 auto">
					<tr>
						<td style="text-align:left;width:150px;vertical-align:top">
							Gap interval
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $gapInterval?>" name="gapInterval"><br>this is the default gap interval in minutes. If the interval between two subsequent records in your database is equal to or longer than this value, it will be considered as a gap.<br><br>
						</td>
					</tr>
				</table>
				<div style="width:98%;margin:0 auto;text-align:justify">
					Now you need to set the default limits (this can be changed directly on the page, but these are the numbers that will be prefilled). For each parameter you specify the minimum and maximum for each month. If the value in the database for that parameter and month is equal to or smaller/larger than this, it will be considered as an outlier and displayed to you.<br>Simply provide the numbers for each, in the order of the months in the year - i.e. value for January, February,..... December.<br><br><strong>NOTE !!! - these number must be given in the units that they are in in the DATABASE - not the ones you choose to display on the page! In other words, this must correspond to the units specified in the main setup as units of the database!</strong>
				</div>
				<table style="width:98%;margin:0 auto">
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Minimum temperature
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $tempMin?>" name="tempMin" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Maximum temperature
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $tempMax?>" name="tempMax" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Minimum humidity
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $humidityMin?>" name="humidityMin" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Maximum humidity
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $humidityMax?>" name="humidityMax" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Minimum pressure
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $pressureMin?>" name="pressureMin" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Maximum pressure
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $pressureMax?>" name="pressureMax" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Maximum wind speed
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $windMax?>" name="windMax" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Maximum wind gust
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $gustMax?>" name="gustMax" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Maximum daily rain
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $rainMax?>" name="rainMax" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Minimum apparent temperature
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $apparentMin?>" name="apparentMin" style="width:600px">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:250px;vertical-align:top">
							Maximum apparent temperature
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $apparentMax?>" name="apparentMax" style="width:600px">
						</td>
					</tr>
				</table>
				<br><br>
				<div style="width:98%;margin:0 auto;text-align:justify">
					Now you need to set the maximum acceptable rate of change. This is given as the maximum rate of change per 10 minutes. If the value for that parameter changes at a higher rate, it will be displayed as "spike". Remember this is always converted to rate of change in 10 minutes. So, for example if your database is updated every 5 minutes, than if two consequtive values have a change of just half of what you specify here, it will be considered a spike. Likewise, if for example there is a longer gap in your records, a larger change will be accepted. Again, this is in the units you have in the database. 
				</div>
				<br><br>
				<table style="width:98%;margin:0 auto">
					<tr>
						<td style="text-align:left;width:150px;vertical-align:top">
							Temperature rate
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $tempRate?>" name="tempRate"> maximum rate of change of temperature per 10 minutes.<br><br>
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:150px;vertical-align:top">
							Humidity rate
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $humidityRate?>" name="humidityRate"> maximum rate of change of humidity per 10 minutes<br><br>
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:150px;vertical-align:top">
							Pressure rate
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $pressureRate?>" name="pressureRate"> maximum rate of change of pressure per 10 minutes<br><br>
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:150px;vertical-align:top">
							Rain rate
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $rainRate?>" name="rainRate"> maximum rate of change of precipitation per 10 minutes<br><br>
						</td>
					</tr>
				</table>
				<div style="width:50%;text-align:center;margin:0 auto">
					<input type="submit" value="Save" class="button2">
				</div>
			</form>
		</div>
		<?php include($baseURL."footer.php")?>
	</body>
</html>